﻿--inimigos tem 2% de chance de dropar item
--blocos tem 5% de chance de dropar item
--usar algum offset Y pra usar o sprite de um char maior que 32p mas manter sua área de colisão como 32x32

--movimentação nos vãos dos blocos
--inimigos
--animações (movimento)
--objetos característicos de stages (teleporte, gangorra, mola, cano) (devo posicioná-los primeiro, para não criar blocos na mesma coordenada)
--trocar player[1] por player[i] para habilitar 2 ou mais jogadores

cellsize = 32
cols_len = 0
bump = require 'bump'
world = bump.newWorld(cellsize)
math.randomseed(os.time())

require "functions"
require "players"
require "stages"
require "controls"
require "powerups"
require "stages"

function love.load(args)
	player = {}
	focus = {img_menu = love.graphics.newImage("/images/focus_menu.png"),
			 option = 1,
			 x = 30,
			 y = 30,
			 }
	menu = {option = 1}

	eff = {explosion = love.graphics.newImage("/images/powerup_s.png")} --lista dos efeitos de partículas

	game = {state = "stage_01", status = "playing"}
	
	explosions = {}--armazena as explosões ocorridas

	CreatePlayer(1)

	world:add(player[1],player[1].x,player[1].y,player[1].w,player[1].h)
	LoadStage()
	
end

function love.update(dt)
	ControlUpdate(dt)
	if game.status == "playing" then
		--CollisionUpdate()
		BombUpdate(dt)
		ExplosionUpdate(dt)
		explosion.particle:update(dt)
		breaked.particle:update(dt)
	end
	collectgarbage("collect")
end

function love.draw(dt)
	local z = 999
	--[[menu
	--jogar 1p
	--jogar 2p
	--ajuda, baixa importância
	--sair, sem importância]]

	if game.state == "stage_01" then
		--primeiro, o piso
		for i = 0, stage_x do
			for j = 0, stage_y do
				love.graphics.draw(stage.img_ground, i*cellsize, j*cellsize)--table.insert(stage.ground)
			end
		end

		--HUD (pesquisar exibição de FPS, memória, ping/ms, e outras informações úteis para debug)
		love.graphics.printf({{10,10,255},"PLAYER 1: LIFE(S) = "..player[1].life.."       SCORE = "..player[1].score},10,540,z)

		for i, block in pairs (stage.blocks) do love.graphics.draw(stage.img_block, block.x, block.y) end
		for i, breakable in pairs(stage.breakables) do love.graphics.draw(stage.img_breakable, breakable.x, breakable.y) end
		
		for i, bomb in pairs (player[1].bombs) do love.graphics.draw(player[1].bomb.img, bomb.x, bomb.y) end
		for i, powerup in pairs (powerups_on) do love.graphics.draw(powerup.powerup.image, powerup.x, powerup.y) end
		
		love.graphics.draw(explosion.particle)
		love.graphics.draw(breaked.particle)
		love.graphics.draw(player[1].sprite, player[1].x, player[1].y)--for player in pairs (players), if player.life > 0
	end
end

function BombUpdate(dt)
	for i, bomb in pairs (player[1].bombs) do
		player[1].bombs[i].fuse = bomb.fuse - dt
		if bomb.moving == "h" then player[1].bombs[i].x = bomb.x + bomb.speed * dt end --bomba chutada
		if bomb.moving == "v" then player[1].bombs[i].y = bomb.y + bomb.speed * dt end
		if bomb.fuse < 0 then BombExplode(bomb,i,1) end
	end
end

function BombExplode(bomb,b,p)
	local newExplosion = {}
	--checar de quem é a bomba, pra escolher a cor da explosão na partícula (adicionar atributo owner na bomba)
	local l,r,u,d = 0,0,0,0
	newExplosion = {x = bomb.x, y = bomb.y, lifetime=explosion_lifetime, name="explosion", pattern="+"}--patterns: +, x, o
	CheckPath(newExplosion,"center")
			
	for i=1, player[1].fire do
		if l == 0 then l = CheckPath({x = bomb.x - cellsize*i, y = bomb.y, lifetime=explosion_lifetime, name="explosion"},l) end
		if r == 0 then r = CheckPath({x = bomb.x + cellsize*i, y = bomb.y, lifetime=explosion_lifetime, name="explosion"},r) end
		if u == 0 then u = CheckPath({x = bomb.x, y = bomb.y - cellsize*i, lifetime=explosion_lifetime, name="explosion"},u) end
		if d == 0 then d = CheckPath({x = bomb.x, y = bomb.y + cellsize*i, lifetime=explosion_lifetime, name="explosion"},d) end
	end
	--definir aqui que a imagem do primeiro e do último elemento do vetor são as bordas da explosão, e o meio é a imagem de junção
	world:remove(bomb)
	table.remove(player[1].bombs, b)--player[p].bombs[b] = nil
end

function CheckPath(object,side)
	local items, n_items = world:queryRect(object.x,object.y,cellsize,cellsize)
	local posx, posy
	
	if object.name == "explosion" then
		for j, item in pairs(items) do
			if item.name == "block" then
				side = 1
			elseif item.name == "breakable" then
				side = 2 --if bomb.piercing == "n" then
				BreakBreakable(item)
			elseif item.name == "bomb" and side ~= "center" then
				side = 3
				--bug: se colocar 2 bombas ao lado da outra, elas explodem 2 breakables (a bomba explodida deve considerar a colisão da bomba que a explodiu)
				item.fuse = -1 --BombExplode(item,item.id,1)
			elseif item.name == "player" then --trocar a precisão de 50% para 66%, colocar uma função de morte do player (player, harm)
				if math.floor(player[1].x % cellsize) < 16 then posx = math.floor(player[1].x/cellsize) else posx = math.ceil(player[1].x/cellsize) end
				if math.floor(player[1].y % cellsize) < 16 then posy = math.floor(player[1].y/cellsize) else posy = math.ceil(player[1].y/cellsize) end
				if posx == object.x/cellsize and posy == object.y/cellsize then player[1].life = player[1].life - 1 end
			elseif item.name == "enemy" then
				--item.life = item.life - 1
			elseif item.name == "powerup" then
				PickPowerup(item)
			end
		end
		if side == 0 or side == "center" then --essa linha impede de criar explosão em cima das coisas que bloqueiam explosão
			explosion.particle:setPosition(object.x+1, object.y+1)
			explosion.particle:emit(1)
			table.insert(explosions, object)
			world:add(object,object.x,object.y,cellsize,cellsize)		
		end
		return side
	elseif object.name == "bomb" then
		for j, item in pairs(items) do
			if item.name == "block" then side = 1
			elseif item.name == "breakable" then side = 2
			elseif item.name == "bomb" then side = 3
			elseif item.name == "explosion" then object.fuse = -1
			end
		end
		if side == 0 or side == "center" then
			table.insert(player[1].bombs, object)
			world:add(object,object.x,object.y,cellsize,cellsize)		
		end
		return side
	end
end

function ExplosionUpdate(dt)
	for i, explosion in pairs (explosions) do
		explosions[i].lifetime = explosion.lifetime - dt
		if explosion.lifetime < 0 then
			world:remove(explosion)
			table.remove(explosions, i)
		end
	end
end

function BreakBreakable(breakable)
	breaked.particle:setPosition(breakable.x,breakable.y)
	breaked.particle:emit(1)
	world:remove(breakable)
	if math.random(1,100) <= 50 then DropPowerup(breakable) end
	stage.breakables[breakable.id] = nil--table.remove(breakables, breakable.id)
end

function DropPowerup(pos)
	local newPowerup = {x = pos.x, y = pos.y, powerup = powerups[math.random(1,4)], id = #powerups_on+1, name="powerup"}
	powerups_on[newPowerup.id] = newPowerup--table.insert(powerups_on, newPowerup)
	world:add(newPowerup,pos.x,pos.y,cellsize,cellsize)
end

function PickPowerup(powerup,picker) --usar essa mesma função pra remover bombas/itens ao morrer
	if picker then
		if powerup.powerup.bonus == "bomb"then --and picker.n_bomb < 8
			picker.n_bomb = picker.n_bomb + powerup.powerup.value
		elseif powerup.powerup.bonus == "fire"then --and picker.fire < 8
			picker.fire = picker.fire + powerup.powerup.value
		elseif powerup.powerup.bonus == "speed"then --and picker.speed < 200
			picker.speed = picker.speed + powerup.powerup.value
		elseif powerup.powerup.bonus == "heart"then
			picker.life = picker.life + powerup.powerup.value
		elseif powerup.powerup.bonus == "kick"then
			picker.shoe = "y"
		elseif powerup.powerup.bonus == "punch"then
		end
	end
	print(powerup.id)
	world:remove(powerup)
	powerups_on[powerup.id] = nil --table.remove(powerups_on, powerup.id)
end